package de.mannheim.ids.sruws.test;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpHeaders;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;

public class TestClient {
		
	public static void main(String arg[]) throws IOException{
		String url =
				//"http://localhost:8080/SRU-WS/";
				"http://clarin.ids-mannheim.de/sruws/";
		
		HttpClient client = HttpClients.createDefault();
		HttpPost post = new HttpPost(url);		
		post.setHeader(HttpHeaders.ACCEPT,"text/query-cql");		
		
		List<NameValuePair> urlParameters = new ArrayList<NameValuePair>();
		urlParameters.add(new BasicNameValuePair("query", "Baden-Württemberg"));
		urlParameters.add(new BasicNameValuePair("maximumRecords", "5"));
		urlParameters.add(new BasicNameValuePair("endpoint", "korap")); 
		post.setEntity(new UrlEncodedFormEntity(urlParameters));
				
		HttpResponse response = client.execute(post);
		System.out.println("Sending 'POST' request to URL : " + url);
		System.out.println("Post parameters : " + post.getEntity());
		System.out.println("Response Code : " + 
				response.getStatusLine().getStatusCode());
		if (response.getStatusLine().getStatusCode() != 200){
			System.out.println("Response Code : " + 
					response.getStatusLine().getReasonPhrase());
		}
				
		FileWriter fw = new FileWriter(new File("test.xml"));
		
		BufferedReader reader = new BufferedReader(new InputStreamReader(
				response.getEntity().getContent()));
		String line;
		while ((line = reader.readLine()) != null){
			//System.out.println(line);
			fw.append(line+"\n");
		}
		fw.close();
	}	
}
